## klapki 0.1.0

=== Makefile ===
# The MIT License (MIT)

# Copyright (c) 2020 наб <nabijaczleweli@nabijaczleweli.xyz>

# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
# COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
# IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
# CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


include configMakefile


LDDLLS := efivar efiboot crypto $(OS_LD_LIBS)
LDAR := $(LNCXXAR) $(foreach l,,-L$(BLDDIR)$(l)) $(foreach dll,$(LDDLLS),-l$(dll))
INCAR := $(foreach l,$(foreach l,fmt,$(l)/include) Catch2/single_include/catch2,-isystemext/$(l)) $(foreach l,,-isystem$(BLDDIR)$(l)/include) -isystemext
VERAR := $(foreach l,KLAPKI,-D$(l)_VERSION='$($(l)_VERSION)')
SOURCES := $(sort $(wildcard $(SRCDIR)*.cpp $(SRCDIR)**/*.cpp $(SRCDIR)**/**/*.cpp $(SRCDIR)**/**/**/*.cpp))
TEST_SOURCES := $(sort $(wildcard $(TSTDIR)*.cpp $(TSTDIR)**/*.cpp $(TSTDIR)**/**/*.cpp $(TSTDIR)**/**/**/*.cpp))
MANPAGE_SOURCES := $(sort $(wildcard $(MANDIR)*.md $(MANDIR)**/*.md))

# Building with -flto on Clang means we can't make useful $(ARCH)es, so don't
LIBFMT := $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))


.PHONY : all clean build build-test man fmt


all : fmt build man build-test test

test: build-test
	$(OUTDIR)klapki-test$(EXE)

clean :
	rm -rf $(OUTDIR)

build : fmt $(OUTDIR)klapki$(EXE)
build-test : fmt $(OUTDIR)klapki-test$(EXE)
man : $(subst $(MANDIR),$(OUTDIR)man/,$(MANPAGE_SOURCES))
fmt : $(LIBFMT)


$(OUTDIR)klapki$(EXE) : $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(SOURCES))) $(LIBFMT)
	$(CXX) $(CXXAR) -o$@ $^ $(PIC) $(LDAR)
	$(STRIP) $(STRIPAR) $@

$(OUTDIR)klapki-test$(EXE) : $(subst $(TSTDIR),$(BLDDIR)test/,$(subst .cpp,$(OBJ),$(TEST_SOURCES))) $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(filter-out $(SRCDIR)main.cpp,$(SOURCES)))) $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))
	$(CXX) $(CXXAR) -o$@ $^ $(PIC) $(LDAR)

$(subst $(MANDIR),$(OUTDIR)man/,$(MANPAGE_SOURCES)) : $(MANDIR)index.txt $(MANPAGE_SOURCES)
	@rm -rf $(dir $@) && mkdir -p $(dir $@)
	cp $^ $(dir $@)
	ronn $@
	ronn -f $@


$(OBJDIR)%$(OBJ) : $(SRCDIR)%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) $(INCAR) $(VERAR) -c -o$@ $^

$(BLDDIR)test/%$(OBJ) : $(TSTDIR)%.cpp
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) $(INCAR) -I$(SRCDIR) $(VERAR) -c -o$@ $^

$(BLDDIR)fmt/obj/%$(OBJ) : ext/fmt/src/%.cc
	@mkdir -p $(dir $@)
	$(CXX) $(CXXAR) -Iext/fmt/include -c -o$@ $^

=== debian/changelog ===
klapki (0.1.0-1) unstable; urgency=medium

  * Initial packaging, upstream version 0.1.0

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 26 Sep 2020 14:49:11 +0200

=== debian/control ===
Source: klapki
Section: admin
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/klapki.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/klapki.deb
Homepage: https://sr.ht/~nabijaczleweli/klapki.deb
Build-Depends: debhelper,
               debhelper-compat (= 13),
               libfmt-dev,
               libssl-dev,
               libefivar-dev,
               libefiboot-dev,
               ronn (>= 0.9.0),
#              ^ ronn before that fails with regex+locale related errors
               locales,
#              ^ we need to generate some locales for ronn

Package: klapki
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c++, admin::boot, interface::commandline, role::program,
 scope::utility
Description: EFI boot manager; or, well, an EFI bootorder compiler.
 klapki(8) generates and manages EFI boot entries on compatible platforms,
 with minimal state and no EFI-side code.
 .
 This package also provides integration with the standard Debian bootloader
 hooks.

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))
TEMPDIR = $(CURDIR)/debian/tmp/
VERSION = $(shell awk '/^version/ {print $$3}' Cargo.toml | sed 's/"//g')


override_dh_auto_build:
	mkdir -p $(TEMPDIR)
	localedef -i en_GB -c -f UTF-8 -A /usr/share/locale/locale.alias $(TEMPDIR)en_GB.UTF-8
	LOCPATH="$(TEMPDIR)" LC_CTYPE="en_GB.UTF-8" ronn -r --organization="klapki developers" man/*.md
	$(MAKE) build STRIP="echo > /dev/null" CXX="$(CXX)" OS_LD_LIBS="fmt"

# We don't include Catch2, so no tests for us
override_dh_auto_test:

override_dh_auto_clean:
	rm -f $(wildcard man/*.8)
	$(MAKE) clean

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md

override_dh_ucf:
	dh_ucf -A
	sed -i 's/\tucf /\tucf --debconf-ok /' $(foreach l,inst rm,debian/klapki.post$(l).debhelper)

%:
	dh $@

## klapki 0.1.1

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 TEST_SOURCES := $(sort $(wildcard $(TSTDIR)*.cpp $(TSTDIR)**/*.cpp $(TSTDIR)**/**/*.cpp $(TSTDIR)**/**/**/*.cpp))
 MANPAGE_SOURCES := $(sort $(wildcard $(MANDIR)*.md $(MANDIR)**/*.md))
 
-# Building with -flto on Clang means we can't make useful $(ARCH)es, so don't
+# Building with -flto on Clang means we can't make useful archives, so don't
 LIBFMT := $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))
 
 
@@ -62,8 +62,8 @@
 $(subst $(MANDIR),$(OUTDIR)man/,$(MANPAGE_SOURCES)) : $(MANDIR)index.txt $(MANPAGE_SOURCES)
 	@rm -rf $(dir $@) && mkdir -p $(dir $@)
 	cp $^ $(dir $@)
-	ronn $@
-	ronn -f $@
+	ronn --organization="klapki developers"    $@
+	ronn --organization="klapki developers" -f $@
 
 
 $(OBJDIR)%$(OBJ) : $(SRCDIR)%.cpp

=== debian/changelog ===
klapki (0.1.1-1) unstable; urgency=medium

  * New upstream version 0.1.1
  * Use upstream makefile to build manpages
  * Include screenshot in /usr/share/doc/klapki

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 26 Feb 2021 19:20:25 +0100

klapki (0.1.0-3) unstable; urgency=medium

  * Fix upstream homepage link
  * Split debconf into config script
  * Use po-debconf for translations
  * Fix interface assumptions in templates
  * Don't overwrite user's /etc/klapki/cmdline on first install, if any

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 04 Oct 2020 19:43:05 +0200

klapki (0.1.0-2) unstable; urgency=medium

  * Handle left-over boot entries better in postrm

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 26 Sep 2020 21:39:15 +0200

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,10 @@
 Rules-Requires-Root: no
 Vcs-Git: https://git.sr.ht/~nabijaczleweli/klapki.deb
 Vcs-Browser: https://git.sr.ht/~nabijaczleweli/klapki.deb
-Homepage: https://sr.ht/~nabijaczleweli/klapki.deb
+Homepage: https://sr.ht/~nabijaczleweli/klapki
 Build-Depends: debhelper,
                debhelper-compat (= 13),
+               po-debconf,
                libfmt-dev,
                libssl-dev,
                libefivar-dev,

=== debian/rules ===
--- 
+++ 
@@ -13,18 +13,16 @@
 override_dh_auto_build:
 	mkdir -p $(TEMPDIR)
 	localedef -i en_GB -c -f UTF-8 -A /usr/share/locale/locale.alias $(TEMPDIR)en_GB.UTF-8
-	LOCPATH="$(TEMPDIR)" LC_CTYPE="en_GB.UTF-8" ronn -r --organization="klapki developers" man/*.md
-	$(MAKE) build STRIP="echo > /dev/null" CXX="$(CXX)" OS_LD_LIBS="fmt"
+	LOCPATH="$(TEMPDIR)" LC_CTYPE="en_GB.UTF-8" $(MAKE) build man CXX="$(CXX)" OS_LD_LIBS="fmt"
 
 # We don't include Catch2, so no tests for us
 override_dh_auto_test:
 
 override_dh_auto_clean:
-	rm -f $(wildcard man/*.8)
 	$(MAKE) clean
 
 override_dh_installdocs:
-	dh_installdocs $(wildcard TODO) README.md
+	dh_installdocs $(wildcard TODO) README.md screenshot.png
 
 override_dh_ucf:
 	dh_ucf -A

## klapki 0.2.0

=== Makefile ===
--- 
+++ 
@@ -29,16 +29,17 @@
 VERAR := $(foreach l,KLAPKI,-D$(l)_VERSION='$($(l)_VERSION)')
 SOURCES := $(sort $(wildcard $(SRCDIR)*.cpp $(SRCDIR)**/*.cpp $(SRCDIR)**/**/*.cpp $(SRCDIR)**/**/**/*.cpp))
 TEST_SOURCES := $(sort $(wildcard $(TSTDIR)*.cpp $(TSTDIR)**/*.cpp $(TSTDIR)**/**/*.cpp $(TSTDIR)**/**/**/*.cpp))
-MANPAGE_SOURCES := $(sort $(wildcard $(MANDIR)*.md $(MANDIR)**/*.md))
+MANPAGES := $(subst man/,,$(wildcard man/*.8))
 
 # Building with -flto on Clang means we can't make useful archives, so don't
 LIBFMT := $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))
 
 
-.PHONY : all clean build build-test man fmt
+.PHONY : all clean build build-test manpages htmlpages fmt
+.SECONDARY:
 
 
-all : fmt build man build-test test
+all : fmt build manpages htmlpages build-test test
 
 test: build-test
 	$(OUTDIR)klapki-test$(EXE)
@@ -48,7 +49,8 @@
 
 build : fmt $(OUTDIR)klapki$(EXE)
 build-test : fmt $(OUTDIR)klapki-test$(EXE)
-man : $(subst $(MANDIR),$(OUTDIR)man/,$(MANPAGE_SOURCES))
+manpages : $(patsubst %,$(OUTDIR)man/%,$(MANPAGES))
+htmlpages : $(patsubst %,$(OUTDIR)man/%.html,$(MANPAGES)) $(OUTDIR)man/style.css
 fmt : $(LIBFMT)
 
 
@@ -59,11 +61,23 @@
 $(OUTDIR)klapki-test$(EXE) : $(subst $(TSTDIR),$(BLDDIR)test/,$(subst .cpp,$(OBJ),$(TEST_SOURCES))) $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(filter-out $(SRCDIR)main.cpp,$(SOURCES)))) $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))
 	$(CXX) $(CXXAR) -o$@ $^ $(PIC) $(LDAR)
 
-$(subst $(MANDIR),$(OUTDIR)man/,$(MANPAGE_SOURCES)) : $(MANDIR)index.txt $(MANPAGE_SOURCES)
-	@rm -rf $(dir $@) && mkdir -p $(dir $@)
-	cp $^ $(dir $@)
-	ronn --organization="klapki developers"    $@
-	ronn --organization="klapki developers" -f $@
+# The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
+# Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
+$(OUTDIR)man/% : man/%
+	@mkdir -p $(dir $@)
+	awk '$$0 == ".Dd" {$$2 = "$(KLAPKI_DATE)"}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  $$0 == ".Os" {$$2 = "klapki"; $$3 = $(KLAPKI_VERSION)}  {print}' $< > $@
+	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: input text line longer than 80 bytes:' -e 'STYLE: operating system explicitly specified: Os klapki'
+
+# https://manpages.debian.org/bullseye/SHA1.3ssl
+$(OUTDIR)man/%.html : $(OUTDIR)man/%
+	@mkdir -p $(dir $@)
+	$(MANDOC) -Thtml -Ostyle="style.css",man="https://manpages.debian.org/bullseye/%N.%S" $< | \
+		awk '/^<h1/ {in_syn = $$0 ~ /id="SYNOPSIS"/}  /^<br/ {if(in_syn) {print >"/dev/stderr"; next}}  {print}' | \
+		sed -Ee 's/ title=".."//g' -e 's/<a class="permalink" href="#([^"]*)"><span class="No" id="([^"]*)">/<a><span class="No">/g' > $@
+
+$(OUTDIR)man/style.css : man/style.css
+	@mkdir -p $(dir $@)
+	cp $^ $@
 
 
 $(OBJDIR)%$(OBJ) : $(SRCDIR)%.cpp

=== debian/changelog ===
klapki (0.2.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Wed, 01 Dec 2021 00:35:25 +0100

klapki (0.2.0-1) unstable; urgency=medium

  * Fix undue error given when purging after /etc/klapki was removed
  * Simplify postinst script and hostid deduction
  * New upstream version 0.2.0
  * Replace ronn instrumentation with mandoc
  * Include all screenshots as documentation
  * Replace patch with setting KLAPKI_{VERSION,DATE} in d/rules
  * Add upstream changelog

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Wed, 01 Dec 2021 00:27:12 +0100

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))


override_dh_auto_build:
	$(MAKE) build manpages CXX="$(CXX)" OS_LD_LIBS="fmt" KLAPKI_VERSION='"$(shell sed 's/^[^(]*(//;s/).*$$//;q' debian/changelog #))"' KLAPKI_DATE="$(shell awk '/^ -- / {sub(/^ -- .*>/, ""); sub(/^0/, "", $$2); print $$3 " " $$2 ", " $$4; exit}' debian/changelog | sed -E 's/Jan/&uary/;s/Feb/&ruary/;s/Mar/&ch/;s/Apr/&il/;s/Jun/&e/;s/Jul/&y/;s/Aug/&ust/;s/Sep/&tember/;s/Oct/&ober/;s/Nov|Dec/&ember/')"

# We don't include Catch2, so no tests for us
override_dh_auto_test:

override_dh_auto_clean:
	$(MAKE) clean

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md $(wildcard screenshot*.png)

override_dh_ucf:
	dh_ucf -A
	sed -i 's/\tucf /\tucf --debconf-ok /' $(foreach l,inst rm,debian/klapki.post$(l).debhelper)

%:
	dh $@

## klapki 0.2.1

=== debian/changelog ===
klapki (0.2.1-1~bpo11) bullseye; urgency=medium

  * Rebuild for bullseye.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 29 Oct 2022 22:14:15 +0200

klapki (0.2.1-1) unstable; urgency=medium

  * New upstream version 0.2.1
    - Drop -lfmt dependency injection, upstream depends on libfmt now
    - Build-depend on catch2 and run tests if !nocheck
  * Clean up default /e/k/description
  * Clear up d/klapki.postrm entries-left message
  * Predicate documentation generation and mandoc dependency on !nodoc
  * Add patch to use -lCatch2WithMain instead of building test/main.cpp
  * d/post-update.d: remove debug log if klapki not installed
  * d/klapki.postinst
    - protect first-install /e/k/cmdline against
       %c-like expansion with sh echo
    - also strip out '^\kernel-image' from autogenerated cmdline
    (reported by rozbrajaczpoziomow <rozbrajaczpoziomow@gmail.com>)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sat, 29 Oct 2022 21:10:12 +0200

=== debian/control ===
--- 
+++ 
@@ -9,15 +9,13 @@
 Homepage: https://sr.ht/~nabijaczleweli/klapki
 Build-Depends: debhelper,
                debhelper-compat (= 13),
+               mandoc <!nocheck>,
                po-debconf,
+               catch2 <!nocheck>,
                libfmt-dev,
                libssl-dev,
                libefivar-dev,
                libefiboot-dev,
-               ronn (>= 0.9.0),
-#              ^ ronn before that fails with regex+locale related errors
-               locales,
-#              ^ we need to generate some locales for ronn
 
 Package: klapki
 Architecture: linux-any

=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

CXX := $(CXX) $(subst -O2,,$(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS))

targets := build
ifeq "$(filter nocheck,$(DEB_BUILD_PROFILES))" ""
targets += build-test
endif
ifeq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
targets += manpages
endif


override_dh_auto_build:
	$(MAKE) $(targets) CXX="$(CXX)" KLAPKI_VERSION='"$(shell sed 's/^[^(]*(//;s/).*$$//;q' debian/changelog #))"' KLAPKI_DATE="$(shell awk '/^ -- / {sub(/^ -- .*>/, ""); sub(/^0/, "", $$2); print $$3 " " $$2 ", " $$4; exit}' debian/changelog | sed -E 's/Jan/&uary/;s/Feb/&ruary/;s/Mar/&ch/;s/Apr/&il/;s/Jun/&e/;s/Jul/&y/;s/Aug/&ust/;s/Sep/&tember/;s/Oct/&ober/;s/Nov|Dec/&ember/')"

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_PROFILES))" ""
	$(MAKE) test
endif

override_dh_auto_clean:
	$(MAKE) clean

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
ifeq "$(filter nodoc,$(DEB_BUILD_PROFILES))" ""
	dh_installdocs $(wildcard TODO) README.md $(wildcard screenshot*.png)
endif

override_dh_ucf:
	dh_ucf -A
	sed -i 's/\tucf /\tucf --debconf-ok /' $(foreach l,inst rm,debian/klapki.post$(l).debhelper)

%:
	dh $@

## klapki 0.2.2

=== Makefile ===
--- 
+++ 
@@ -24,49 +24,45 @@
 
 
 LDDLLS := efivar efiboot crypto $(OS_LD_LIBS)
-LDAR := $(LNCXXAR) $(foreach l,,-L$(BLDDIR)$(l)) $(foreach dll,$(LDDLLS),-l$(dll))
-INCAR := $(foreach l,$(foreach l,fmt,$(l)/include) Catch2/single_include/catch2,-isystemext/$(l)) $(foreach l,,-isystem$(BLDDIR)$(l)/include) -isystemext
+LDAR := $(LNCXXAR) $(foreach dll,$(LDDLLS),-l$(dll)) $(shell { command -v pkg-config > /dev/null && pkg-config --libs fmt; } || echo -lfmt)
+INCAR := -isystemext $(shell for p in catch2 fmt; do pkg-config --cflags $p; done 2>/dev/null)
 VERAR := $(foreach l,KLAPKI,-D$(l)_VERSION='$($(l)_VERSION)')
 SOURCES := $(sort $(wildcard $(SRCDIR)*.cpp $(SRCDIR)**/*.cpp $(SRCDIR)**/**/*.cpp $(SRCDIR)**/**/**/*.cpp))
 TEST_SOURCES := $(sort $(wildcard $(TSTDIR)*.cpp $(TSTDIR)**/*.cpp $(TSTDIR)**/**/*.cpp $(TSTDIR)**/**/**/*.cpp))
 MANPAGES := $(subst man/,,$(wildcard man/*.8))
 
-# Building with -flto on Clang means we can't make useful archives, so don't
-LIBFMT := $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))
 
-
-.PHONY : all clean build build-test manpages htmlpages fmt
+.PHONY : all clean build build-test manpages htmlpages
 .SECONDARY:
 
 
-all : fmt build manpages htmlpages build-test test
+all : build manpages htmlpages build-test test
 
 test: build-test
-	$(OUTDIR)klapki-test$(EXE)
+	$(OUTDIR)klapki-test
 
 clean :
 	rm -rf $(OUTDIR)
 
-build : fmt $(OUTDIR)klapki$(EXE)
-build-test : fmt $(OUTDIR)klapki-test$(EXE)
+build : $(OUTDIR)klapki
+build-test : $(OUTDIR)klapki-test
 manpages : $(patsubst %,$(OUTDIR)man/%,$(MANPAGES))
 htmlpages : $(patsubst %,$(OUTDIR)man/%.html,$(MANPAGES)) $(OUTDIR)man/style.css
-fmt : $(LIBFMT)
 
 
-$(OUTDIR)klapki$(EXE) : $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(SOURCES))) $(LIBFMT)
-	$(CXX) $(CXXAR) -o$@ $^ $(PIC) $(LDAR)
+$(OUTDIR)klapki : $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(SOURCES)))
+	$(CXX) $(CXXAR) -o$@ $^ $(LDAR)
 	$(STRIP) $(STRIPAR) $@
 
-$(OUTDIR)klapki-test$(EXE) : $(subst $(TSTDIR),$(BLDDIR)test/,$(subst .cpp,$(OBJ),$(TEST_SOURCES))) $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(filter-out $(SRCDIR)main.cpp,$(SOURCES)))) $(patsubst ext/fmt/src/%.cc,$(BLDDIR)fmt/obj/%$(OBJ),$(wildcard ext/fmt/src/*.cc))
-	$(CXX) $(CXXAR) -o$@ $^ $(PIC) $(LDAR)
+$(OUTDIR)klapki-test : $(subst $(TSTDIR),$(BLDDIR)test/,$(subst .cpp,$(OBJ),$(TEST_SOURCES))) $(subst $(SRCDIR),$(OBJDIR),$(subst .cpp,$(OBJ),$(filter-out $(SRCDIR)main.cpp,$(SOURCES))))
+	$(CXX) $(CXXAR) -o$@ $^ $(LDAR)
 
 # The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
 # Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
 $(OUTDIR)man/% : man/%
 	@mkdir -p $(dir $@)
 	awk '$$0 == ".Dd" {$$2 = "$(KLAPKI_DATE)"}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  $$0 == ".Os" {$$2 = "klapki"; $$3 = $(KLAPKI_VERSION)}  {print}' $< > $@
-	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: input text line longer than 80 bytes:' -e 'STYLE: operating system explicitly specified: Os klapki'
+	! $(MANDOC) -Tlint $@ 2>&1 | grep -vF -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: input text line longer than 80 bytes:' -e 'STYLE: operating system explicitly specified: Os klapki' -e 'STYLE: no blank before trailing delimiter: Pa /sys/\:firmware/\:efi/\:efivars/\:'
 
 # https://manpages.debian.org/bullseye/SHA1.3ssl
 $(OUTDIR)man/%.html : $(OUTDIR)man/%
@@ -87,7 +83,3 @@
 $(BLDDIR)test/%$(OBJ) : $(TSTDIR)%.cpp
 	@mkdir -p $(dir $@)
 	$(CXX) $(CXXAR) $(INCAR) -I$(SRCDIR) $(VERAR) -c -o$@ $^
-
-$(BLDDIR)fmt/obj/%$(OBJ) : ext/fmt/src/%.cc
-	@mkdir -p $(dir $@)
-	$(CXX) $(CXXAR) -Iext/fmt/include -c -o$@ $^

=== debian/changelog ===
klapki (0.2.2-1) unstable; urgency=medium

  * New upstream version 0.2.2
  * Update upstream changeog

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 12 Jun 2023 18:48:13 +0200

## klapki 0.3.0

=== debian/changelog ===
klapki (0.3.0-1) unstable; urgency=medium

  [ наб ]
  * postinst.d: fully quote all paths
  * d/postinst: printf with \0 | xargs -> just set -- ... and $@

  [ Cicada ]
  * d/po: add fr.po

  [ наб ]
  * Add d/u/signing-key.asc and pgpsigurlmangle to d/watch
  * New upstream version 0.3.0 (+ changelog & NEWS)
    => install locale and bash-completion
  * d/patches: remove, not needed
  * d/copyright: update for new upstream
  * Consider the new upstream /etc/klapki/{host,efi-root} configs in hooks
  * d/u/metadata: add

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Tue, 05 Dec 2023 20:49:58 +0100

## klapki 0.3.1

=== Makefile ===
# SPDX-License-Identifier: MIT


-include Makefile.local

KLAPKI_VERSION ?= "$(patsubst v%,%,$(shell git describe))"
SOURCE_DATE_EPOCH ?= $(shell git log -1 --no-show-signature --format=%at man/klapki.8)
KLAPKI_DATE ?= $(shell LC_ALL=C date -d@$(SOURCE_DATE_EPOCH) '+%B %e, %Y')
MANDOC ?= mandoc
PKGCONF ?= pkgconf
NOLOCREGEN ?=

# Set these to "{}" to compile-time-validate libfmt format strings (on CI)
FGETTEXT  ?= fmt::runtime(gettext({}))
FNGETTEXT ?= fmt::runtime(ngettext({}, plur, cnt))

OUTDIR := out/
BLDDIR := out/build/

CXXFLAGS += -O3 -g -std=c++20 -Wall -Wextra -pipe -fPIC -fno-rtti
CPPFLAGS += -MD $(shell $(PKGCONF) --cflags efivar efiboot fmt libmd zlib 2>/dev/null) -DKLAPKI_VERSION='$(KLAPKI_VERSION)' -D'fgettext(str)=$(subst {},str,$(FGETTEXT))' -D'fngettext(sing, plur, cnt)=$(subst {},sing,$(FNGETTEXT))'
LDLIBS   += $(shell for l in efivar efiboot fmt libmd; do $(PKGCONF) --libs $$l 2>/dev/null || echo -l$${l#lib}; done) $(shell $(PKGCONF) --libs zlib 2>/dev/null || echo -DKLAPKI_NO_ZLIB)

SOURCES := $(sort $(wildcard src/*.cpp))
TEST_SOURCES := $(sort $(wildcard test/*.cpp))
MANPAGES := $(sort $(wildcard man/*.8))
ifneq (,$(shell command -v msgfmt))
	LOCALES := $(wildcard po/*.po)
endif

ifneq "$(findstring clang,$(shell $(CXX) --version))" ""
	# GCC doesn't have this granularity
	CXXFLAGS += -pedantic -Wno-gnu-statement-expression -flto=full
else
	CXXFLAGS += -flto
endif


.PHONY : all clean build build-test manpages htmlpages
.SECONDARY:


all : build locales manpages htmlpages build-test test

test: build-test
	$(OUTDIR)klapki-test

clean :
	rm -rf $(OUTDIR)

build : $(OUTDIR)klapki
build-test : $(OUTDIR)klapki-test
manpages : $(patsubst %,$(OUTDIR)%,$(MANPAGES))
htmlpages : $(patsubst %,$(OUTDIR)%.html,$(MANPAGES)) $(OUTDIR)man/style.css
locales : $(patsubst po/%.po,$(OUTDIR)locale/%/LC_MESSAGES/klapki.mo,$(LOCALES))


$(OUTDIR)klapki : $(patsubst %.cpp,$(BLDDIR)%.o,$(SOURCES))
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o$@ $^ $(LDLIBS)

$(BLDDIR)test/%.o $(OUTDIR)klapki-test : CXXFLAGS += -O0
$(BLDDIR)test/%.o $(OUTDIR)klapki-test : CPPFLAGS += -Isrc/
$(OUTDIR)klapki-test : $(patsubst %.cpp,$(BLDDIR)%.o,$(TEST_SOURCES) $(filter-out src/main.cpp,$(SOURCES)))
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o$@ $^ $(LDLIBS)


$(BLDDIR)klapki.pot: src/*.[ch]pp
	@mkdir -p $(@D)
	$(NOLOCREGEN)xgettext --check=ellipsis-unicode -kfgettext -kfngettext:1,2 --from-code=UTF-8 -c -io- $^ | sed -n '/^#[:.]/,$$p' > $@
	$(NOLOCREGEN)$(foreach l,$(LOCALES),msgmerge --backup=off --no-wrap -Uiq $(l) $@ &&) :
	@>> $@

$(OUTDIR)locale/%/LC_MESSAGES/klapki.mo : po/%.po $(BLDDIR)klapki.pot
	@mkdir -p $(@D)
	msgfmt --statistics --check-format --check-domain -o $@ $<


# The d-v-o-s string starts at "BSD" (hence the "BSD General Commands Manual" default); we're not BSD, so hide it
# Can't put it at the very top, since man(1) only loads mdoc *after* the first mdoc macro (.Dd in our case)
$(OUTDIR)man/% : man/%
	@mkdir -p $(@D)
	awk '$$0 == ".Dd" {$$2 = "$(KLAPKI_DATE)"}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  $$0 == ".Os" {$$2 = "klapki"; $$3 = $(KLAPKI_VERSION)}  {print}' $< > $@
	! $(MANDOC) -Tlint $@ 2>&1 | grep -vF -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'STYLE: input text line longer than 80 bytes:' -e 'STYLE: operating system explicitly specified: Os klapki' -e 'STYLE: no blank before trailing delimiter: Pa /sys/\:firmware/\:efi/\:efivars/\:'

# https://manpages.debian.org/bookworm/SHA1.3
$(OUTDIR)man/%.html : $(OUTDIR)man/%
	@mkdir -p $(@D)
	sed -e 's/^\(\.i[ef]\) n/\1 0/' $< | \
		$(MANDOC) -Thtml -Ostyle="style.css",man="https://manpages.debian.org/bookworm/%N.%S" $< | \
		awk '/^<h1/ {in_syn = $$0 ~ /id="SYNOPSIS"/}  /^<br/ {if(in_syn) {print >"/dev/stderr"; next}}  {print}' | \
		sed -Ee 's/ title=".."//g' -e 's/<a class="permalink" href="#([^"]*)"><span class="No" id="([^"]*)">/<a><span class="No">/g' > $@

$(OUTDIR)man/style.css : man/style.css
	@mkdir -p $(@D)
	cp $^ $@


$(BLDDIR)%.o : %.cpp
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c -o $@ $<


include $(wildcard $(BLDDIR)*/*.d)

=== debian/changelog ===
klapki (0.3.1-1~bpo11+1) bookworm; urgency=medium

  * Rebuild for bookworm.

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Thu, 07 Dec 2023 16:30:43 +0100

klapki (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1 (+ changelog & NEWS)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Thu, 07 Dec 2023 15:52:17 +0100

=== debian/rules ===
#!/usr/bin/make -f


export DEB_BUILD_MAINT_OPTIONS := hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export KLAPKI_VERSION := "$(shell IFS="$$IFS()" read -r _ v _ < debian/changelog && echo "$$v")"
export TZ := UTC0
export NOLOCREGEN := @\#


override_dh_auto_build:
	mkdir -p out/tmp
	dh_auto_build -- build locales $(if $(filter nocheck,$(DEB_BUILD_PROFILES)),,build-test) $(if $(filter nodoc,$(DEB_BUILD_PROFILES)),,manpages)
	ln bash-completion out/tmp/klapki

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs README.md $(wildcard screenshot*.png)
	cp debian/NEWS.upstream debian/klapki/usr/share/doc/klapki/NEWS


override_dh_ucf:
	dh_ucf -A
	sed -i 's/\tucf /\tucf --debconf-ok /' $(foreach l,inst rm,debian/klapki.post$(l).debhelper)

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/klapki-$1\.tar\.gz/, pgpsigurlmangle=s:$:.asc:" \
  https://git.sr.ht/~nabijaczleweli/klapki/refs .*/v?(\d\S+)\.tar\.gz

## klapki 0.3.2

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 SOURCE_DATE_EPOCH ?= $(shell git log -1 --no-show-signature --format=%at man/klapki.8)
 KLAPKI_DATE ?= $(shell LC_ALL=C date -d@$(SOURCE_DATE_EPOCH) '+%B %e, %Y')
 MANDOC ?= mandoc
-PKGCONF ?= pkgconf
+PKG_CONFIG ?= pkgconf
 NOLOCREGEN ?=
 
 # Set these to "{}" to compile-time-validate libfmt format strings (on CI)
@@ -18,8 +18,8 @@
 BLDDIR := out/build/
 
 CXXFLAGS += -O3 -g -std=c++20 -Wall -Wextra -pipe -fPIC -fno-rtti
-CPPFLAGS += -MD $(shell $(PKGCONF) --cflags efivar efiboot fmt libmd zlib 2>/dev/null) -DKLAPKI_VERSION='$(KLAPKI_VERSION)' -D'fgettext(str)=$(subst {},str,$(FGETTEXT))' -D'fngettext(sing, plur, cnt)=$(subst {},sing,$(FNGETTEXT))'
-LDLIBS   += $(shell for l in efivar efiboot fmt libmd; do $(PKGCONF) --libs $$l 2>/dev/null || echo -l$${l#lib}; done) $(shell $(PKGCONF) --libs zlib 2>/dev/null || echo -DKLAPKI_NO_ZLIB)
+CPPFLAGS += -MD $(shell $(PKG_CONFIG) --cflags efivar efiboot fmt libmd zlib 2>/dev/null) -DKLAPKI_VERSION='$(KLAPKI_VERSION)' -D'fgettext(str)=$(subst {},str,$(FGETTEXT))' -D'fngettext(sing, plur, cnt)=$(subst {},sing,$(FNGETTEXT))'
+LDLIBS   += $(shell for l in efivar efiboot fmt libmd; do $(PKG_CONFIG) --libs $$l 2>/dev/null || echo -l$${l#lib}; done) $(shell $(PKG_CONFIG) --libs zlib 2>/dev/null || echo -DKLAPKI_NO_ZLIB)
 
 SOURCES := $(sort $(wildcard src/*.cpp))
 TEST_SOURCES := $(sort $(wildcard test/*.cpp))

=== debian/changelog ===
klapki (0.3.2-1) unstable; urgency=medium

  * Forward dpkg-buildpackage's -j to make
  * New upstream version 0.3.2 (+ changelog & NEWS)
  * Replace ucf for /etc/klapki/description with normal conffile mechanism

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 11 Aug 2024 13:35:19 +0200

=== debian/rules ===
--- 
+++ 
@@ -23,9 +23,5 @@
 	cp debian/NEWS.upstream debian/klapki/usr/share/doc/klapki/NEWS
 
 
-override_dh_ucf:
-	dh_ucf -A
-	sed -i 's/\tucf /\tucf --debconf-ok /' $(foreach l,inst rm,debian/klapki.post$(l).debhelper)
-
 %:
 	dh $@
